#+++
#  RCS $Id: detexcmd.sed,v 14.30.0.9 1994/02/02 19:20:17 tom Exp tom $
#  name:	detexcmd.sed
#  abstract:	sed script to convert JOVEs command reference manual
#		"jovecmds.tex" to very basic nroff to produce online manual.
#  author:	Tom Hageman, Groningen, The Netherlands.
#  description:
#	2U2D (Too ugly to describe).
#
#	This is intended as an intermediary between TeX and the on-line help;
#	use "medieval.sed" script for a more complete nroff translation.
#
#	Conditional code is resolved, and comments are stripped from this
#	script by another sed script from JOVEs Makefile.
#	!!only simple un-nested #ifdef XXX ... #endif are supported!!
#---
1i\
.\\" This file is produced automatically from the LaTeX source "jovecmds.tex"\
.\\" by the sed(1) script "detexcmd.sed" and the JOVE script "derofcmd.jc".\
.\\" !!ANY CHANGES YOU APPLY HERE WILL GO AWAY!!\
.de dc\
\\&\
.sp 1\
:entry "$1" "$2"\
.br\
..\
.de DS\
.sp 1\
.in +5\
.nf\
..\
.de DE\
.fi\
.in -5\
.sp 1\
..\
.lp 70n\
.ll 70n
#ifdef MINIX
1i\
.pl 3000\
.m1 0\
.m2 0\
.m3 0\
.m4 0
#endif
/\\&/s//&\&/g
/^['.]/s//\\\&&/
# spit out verbatim text with (almost) no translation
/\\begin{verbatim}/,/^\\end{verbatim}/{
/\\[a-z]*{verbatim}/!{
s/\\/\\e/g
p
d
}
s/\\[a-z]*{verbatim}//
}
# BEFORE %% comments
s/\([^\\]\){}/\1\\\&/g
/^%/{
/^%%\.ta/d
/^%%/s///p
d
}
/^\\manual{/,/^}/d
/\\onlinehelp{\([^\}]*\)}/s//\1/g
/^\\onlinehelp{/s///
/^\\note{/,/^}/d
# \\NOTE should come AFTER all /^.../ patterns since it indents!
s/^\\dc{\(.*\)}{variable.*/.dc "\1" "Variable"/
s/^\\dc{\(.*\)}{.*/.dc "\1" "Command"/
# ... even if it's a macro
/^\\par\\noindent.*/s//.br/
s/\\linebreak\[.\] *//g
s/\\[Jj]ove/JOVE/g
s/\\UNIX/UNIX/g
s/\\TeX/TeX/g
s/\\lowercase{\([^}]*\)}/\1/g
/~/s/\([^\\]\)~/\1\\ /g
s/\\bs/\\e/g
s/\\carat/^/g
s/\\tilde/~/g
s/\\ldots/.../g
s/\\key{\([^}]*\)}/"\1"/g
s/\\cmd{\([^}]*\)}/"\1"/g
s/\\Def{\([^}]*\)}/`\1'/g
s/\\eg{\([^}]*\)}/`\1'/g
s/\\file{\([^}]*\)}/"\1"/g
s/\\out{\([^}]*\)}/"\1"/g
s/\\mbox{\\tt *\([^}]*\)}/"\1"/g
s/\\mbox{\([^}]*\)}/\1/g
s:{\\em \([^}{]*\)\\/}:*\1*:g
s/{\\[itebs][tmfl] *\([^}]*\)}/\1/g
s/\\,//g
/^ *--/!s/--/-/g
s/ *\\hline$//
s/\(  *\)\&/\1/g
s/\(  *\)\\[>'`]/\1/g
# Tables are now formatted using explicit spacing between .DS ... .DE
# since Minix's nroff can't handle .ta (and JOVE can't either for that matter)
#/	&.*[^\\]$/,/\\\\$/s/^[^	][^	]*$/	&/
#s/		*\& */	/g
s/\\\\$//
#/^\\begin.*{description}/a\
#.ta .5i 1i 1.5i
/^\\begin.*/s//.DS/
/^\\end.*/s//.DE/
/^\\item\[\([^]]*\)\]/s//\1/
/^\\item$/s//.IP " *" 3n/
s/\([^\\]\)$\([^$]*\)\$/\1\2/g
s/^$\([^$]*\)\$/\1/
/^\\NOTE{/,/^}/{
/^\\NOTE{/c\
.IP \-> 3n
/^}/d
#/^\.[^.]/!s/^/   /
}
s/^[{}] *//
s/\([^\\]\)[{}]/\1/g
s/\\\([{}_%#$]\)/\1/g
s/`\\c \([^ ]\)'/`\1 cedille'/g
s/`\\'\([^ ]\)'/`\1 aigu'/g
s/\\Rightarrow/=>/g
s/\\equiv/==/g
s/\\geq/>=/g
s/\\rightarrow/RightArrow/g
s/\\uparrow/UpArrow/g
s/\\Rbrace/}/g
s/""\([^"]*\)"\([^"]*\)"/"$(\1)\2"/
s/\*\(<[^>]*>\)\*/\1/g
s/`"\([^"]*\)"'/`\1'/g
s/("\([^"]*\)")/(\1)/g
#s/[`'"][`'"][`'"]*/"/g		#replaced by:
s/\([`'"]\)\1\1*/"/g
s/"\([a-z][a-z]*([0-9])\)"/\1/g
s/\\[et][mt] *//
# These are handled from the command line so the "derofcmd.jc" post-processor
# can still replace them with `exotic' characters.
#s/ *(\\[^ ][^)]*)/   /g
#s/\\[`~'^"]//g
/^\.DS/,/^\.DE/!{
/^$/d
}
# assume there is only one \cleardoublepage, and it's at the end.
/^\\cleardoublepage/c\
.dc "~~~~The~~~~" "~~~~End~~~~"\
.\\" so blank lines beyond this are ignored
#======================================================================
# $Log: detexcmd.sed,v $
# Revision 14.30.0.9  1994/02/02  19:20:17  tom
# comment fix.
#
# Revision 14.30.0.5  1993/09/28  01:11:45  tom
# (verbatim): rewrite to make it work with (buggy) GNU sed <= 2.03.
#
# Revision 14.30  1993/02/09  23:08:21  tom
# add RCS directives.
#
#======================================================================
