.\" ditroff -man
.\" RCS $Id: jove.nr,v 14.32.0.1 1993/07/30 13:27:15 tom Exp tom $
.hy 0
.TH JOVE 1 "February 10, 1993"
.ad
.SH NAME
jove \- an interactive display-oriented text editor
.SH SYNOPSIS
.RI "jove [+[" n "]] [\-[" n "]] [\-b] [+b]"
.RI "[\-d " directory "] [\-j] [+j " file "]"
.ti +5
.RI "[\-p " file "] [\-s " pattern "]"
.RI "[\-t " tag "] [+t " "tag tagfile" "]"
.ti +5
.RI "[\-v] [+v] [\-w[" n "]] [\-x " command "]"
.ti +5
.RI "[\-set " "variable value" "] [-\- " variable "]"
.RI "[++ " variable "]"
.ti +5
.RI [ files ]
.sp 0
jove \-r
.sp 0
jove \-teach
.sp 0
.RI "jove_recover [\-d" tmp-dir "] [-check]"
.SH DESCRIPTION
JOVE is Jonathan's Own Version of Emacs.  It is based on the original EMACS
editor written at MIT by Richard Stallman.  Although JOVE is meant to be
compatible with EMACS, there are some major differences between the two
editors and you shouldn't rely on their behaving identically.
.LP
JOVE works on any reasonable display terminal that is described in the
.I termcap
file (see termcap(5) for more details).  When you start up JOVE, it checks
to see whether you have your
.I TERM
environment variable set.  On most systems that will automatically be set up
for you, but if it's not JOVE will ask you what kind of terminal you are
using.  To avoid having to type this every time you run JOVE you can set your
.I TERM
environment variable yourself.  How you do this depends on which shell you
are running.  If you are running the C Shell, as most of you are, you type
.sp
.ti +5
.RI "setenv TERM " type
.sp
and with the Bourne Shell, you type
.sp
.ti +5
.RI "TERM=" type "; export TERM"
.sp
where
.I type
is the name of the kind of terminal you are using (e.g., vt100).  If
neither of these works get somebody to help you.
.LP
To exit JOVE, type "C-X C-C".
.SH INVOKING JOVE
If you run JOVE with no arguments you will be placed in an empty buffer,
called
.IR Main .
Otherwise, any arguments you supply are considered file names and each is
"given" its own buffer.  Only the first file is actually read in \- reading
other files is deferred until you actually try to use the buffers they are
attached to.  This is for efficiency's sake: most of the time, when you run
JOVE on a big list of files, you end up editing only a few of them.
.LP
The names of all of the files specified on the command line are saved in a
buffer, called
.I *minibuf*.
The mini-buffer is a special JOVE buffer that is used when JOVE is prompting
for some input to many commands (for example, when JOVE is prompting for a
file name).  When you are being prompted for a file name, you can type C-N
(that's Control-N) and C-P to cycle through the list of files that were
specified on the command line.  The file name will be inserted where you are
typing and then you can edit it as if you typed it in yourself.
.LP
If you
.I pipe
stuff into JOVE, that stuff ends up in the
.I Main
buffer.
.LP
JOVE recognizes the following switches:
.TP
.BI + n
Read the next file and positions point at the
.IR n 'th
line instead of the (default) 1'st line.  If no more files follow, point
of the currently active buffer is positioned.  This can be specified
more than once but it doesn't make sense to use it twice on the same
file; in that case the second one wins. If no numeric argument is given
after the +, the point is positioned at the end of the file.
.TP
.BI \- n
Like
.BI + n
except it positions point at the
.IR n 'th
line
.I before
the end of the file.
.TP
.B \-b
Tell JOVE never to make a backup file when saving a file.
.TP
.B +b
Tell JOVE to make a backup file when saving a file.
.TP
.B \-d
Set current directory to the directory designated by the following argument.
This can speed startup if you are using a shell which does not automatically
maintain the
.I CWD
(or
.IR PWD )
environment variable.
.ig
If
.B \-d
is not specified on a system without a modified C shell, JOVE will have to
figure out the current directory itself, and that can be VERY slow.  You
can simulate the modified C shell by putting the following lines in your
C shell initialization file (.cshrc):
.in +5
.nf
     alias cd        'cd \e!*; setenv CWD $cwd'
     alias popd      'popd \e!*; setenv CWD $cwd'
     alias pushd     'pushd \e!*; setenv CWD $cwd'
.fi
.in -5
..
.TP
.B \-j
Ignore the initialization files in your HOME directory and in the
current directory.  Only the system initialization file is executed.
.TP
.B +j
Execute the commands in the file designated by the following argument.
.TP
.B \-p
Parse the error messages in the file designated by the following argument.
The error messages are assumed to be in a format similar to the C compiler,
LINT, or GREP output.
.TP
.B \-r
Recover your buffers after a crash (see below).
.TP
.B \-s
Search the first occurrence (after point) of the string designated by
the following argument in the current buffer.  Use quotes if the search
string contains spaces or other characters special to the shell.
.TP
.B \-t
Take the following argument and run the
.I find-tag
command on it (see ctags(1)).
.TP
.B +t
Like
.B \-t
but take the file designated by the second following argument, instead of
"./tags", as the file containing the tag definitions.
.TP
.B \-v
Set the next file to
.IR view-mode ,
so that you cannot accidentally change
the contents of that file.  Note that files that are write-protected
are automatically set to
.IR view-mode .
.TP
.B +v
Set all next files to
.IR view-mode .
.TP
.B \-w
Divide the window in two.  If a number directly follows the
.B \-w
divide the window in that many subwindows.  When this happens, the
next files are read until either each window displays a file, or
there are no more files left on the command line.
.TP
.B \-x
Take the following argument and execute it as a JOVE command.  Use quotes
if the command contains spaces or other characters special to the shell.
.TP
.B \-set
Take the next argument as the name of a JOVE variable and set
it to the value designated by the second following argument.
.TP
.B \-\-
Take the next argument as the name of a JOVE boolean variable and set its
value to "off".
.TP
.B ++
Like
.B \-\-
but turn it "on" instead.
.LP
Additional switches may have been defined with JOVEs "command-line-option"
command.
.SH "RECOVERING BUFFERS AFTER A CRASH"
The
.B \-r
option of jove recovers your buffers.  Use this when the system
crashes, or JOVE crashes, or you accidently get logged out while in JOVE.
If there are any buffers to be recovered, this will find them.
.ig \" SYSTEM ADMINISTRATORS ONLY
.LP
If you want JOVE to recover buffers after system crashes, you should add
the line
.sp
.ti +5
(LIBDIR/recover \-preserve) >/dev/console 2>&1
.sp
to your /etc/rc file (after expreserve is run but before /tmp is cleared).
..
.LP
Recover looks for JOVE buffers that are left around and are
owned by you.  (You cannot recover other peoples' buffers, obviously.)
If there were no buffers that were modified at the time of the
crash or there were but recover can't get its hands on them, you will be
informed with the message, "Nothing to recover."  Otherwise,
recover prints the date and time of the version of the buffers it has,
plus a list of these buffers, and then waits for you type a command.
.LP
Most versions of JOVE have a builtin recover which is self-explanatory;
it restores the buffers inside JOVE so you can continue editing right
away.  Other versions run the separate jove_recover program which is
explained below.
.LP
To get a list of the buffers recover knows about, use the
.I list
command.  This will list all the buffers and the files and the number of
lines associated with them.  Next to each buffer is a number.  When you want
to recover a buffer, use the
.I get
command.  The syntax is
.I get buffer filename
where
.I buffer
is either the buffer's name or the number at the beginning of the line.  If
you don't type the buffer name or the filename, recover will prompt you
for them.
.LP
If there are a lot of buffers and you want to recover all of them, use the
.I recover
command.  This will recover each buffer to the name of the buffer with "#"
prepended to the name (so that the original isn't over-written).  It asks
for each file and if you want to restore that buffer to that name you type
"y".  If you want to recover the file but to a different name, just type
the new name in.  If you type "n" recover will skip that file and go on
to the next one.
.LP
If you want to look at a buffer before deciding to recover it, use the
.I print
command.  The syntax for this is
.I print buffer
where
.I buffer
again is either its name or the number.  You can type ^C if you want to
abort printing the file to the terminal, and recover will respond with
an appropriate message.
.LP
When you're done and have all the buffers you want, type the
.I quit
command to leave.  You will then be asked whether it's okay to delete the
tmp files.  Most of the time that's okay and you should type "yes".  When
you say that, JOVE removes all traces of those buffers and you won't be able
to look at them again.  (If you recovered some buffers they will still be
around, so don't worry.)  So, if you're not sure whether you've gotten all
the buffers, you should answer "no" so that you'll be able to run
recover again at a later time (presumably after you've figured out
which ones you want to save).
.LP
If you type ^C at any time other than when you're printing a file to the
terminal, recover will exit without a word.  If you do this but wish you
hadn't, just type "jove \-r" to the shell again, and you will be put back
with no loss.
.LP
If you just want to see whether there are JOVE buffers left around, use
the
.I jove_recover -check
command.  This will print a message when there are buffers to recover,
and keeps quiet if not so.  This is useful in your shell .login (or .profile).
.SH GETTING HELP
Once in JOVE, there are several commands available to get help.  To execute
any JOVE command, you type "<ESC> X command-name" followed by <Return>.  To
get a list of all the JOVE commands you type "<ESC> X" followed by "?".  The
.I describe-bindings
command can be used to get a list containing each key, and its associated
command (that is, the command that gets executed when you type that key).
If you want to save the list of bindings, you can set the jove variable
.I send-typeout-to-buffer
to ON (using the
.I set
command), and then execute the
.I describe-bindings
command.  This will create a buffer and put in it the bindings list it
normally would have printed on the screen.  Then you can save that buffer to
a file and print it to use as a quick reference card.  (See VARIABLES below.)
.LP
Once you know the name of a command, you can find out what it does with the
.I describe-command
command, which you can invoke quickly by typing "ESC ?".  The
.I apropos
command will give you a list of all the command with a specific string in
their names.  For example, if you want to know the names of all the
commands that are concerned with windows, you can run "apropos" with the
keyword
.I window.
.LP
If you're not familar with the EMACS command set, it would be worth your
while to use run TEACHJOVE.  Do do that, just type "jove \-teach" or
"teachjove" to your shell and you will be placed in JOVE in a buffer
which contains directions.  I highly recommend this for beginners; you
may save yourself a lot of time and headaches.
.SH KEY BINDINGS and VARIABLES
You can alter the key bindings in JOVE to fit your personal tastes.  That
is, you can change what a key does every time you strike it.  For example,
by default the C-N key is bound to the command
.I next-line
and so when you type it you move down a line.  If you want to change a
binding or add a new one, you use the
.I bind-to-key
command.  The syntax is "bind-to-key <command> key".
.LP
You can also change the way JOVE behaves in little ways by changing the
value of some variables with the
.I set
command.  The syntax is "set <variable> value", where value is a number or a
string, or "on" or "off", depending on the context.  For example, if you
want JOVE to make backup files, you set the "make-backup-files" variable to
"on".  To see the value of a variable, use the "print <variable>" command.
.SH INITIALIZATION
JOVE automatically reads commands from an initialization file in your HOME
directory, called ".joverc" (unless you invoke jove with the
.B \-j
switch, see above.)  In this file you can place commands that you
would normally type in JOVE.  If you like to rearrange the key bindings and
set some variables every time you get into JOVE, you should put them in your
initialization file.  Here are a few lines as an example:
.in +5
.sp
.nf
     set match-regular-expressions on
     set auto-case-abbrev off
     auto-execute-command auto-fill /tmp/Re\e|.*drft
     read-word-abbrev ~/.joveabbr
     bind-to-key scroll-down ^C
     bind-to-key grow-window ^Xg
     bind-to-key shrink-window ^Xs
     set quiet on
     bind-to-key i-search-forward ^:k1
     bind-to-key i-search-reverse ^:k2
     set quiet off
.fi
.sp
.in -5
(Note that the Control Characters can be either two character sequences
(e.g. ^ and C together as ^C) or the actual control character.  If you want
to use an ^ by itself you must BackSlash it (e.g., bind-to-key grow-window
^X\e^ binds grow-window to "^X^").  The four character sequence ^:ab is not
actually a control character but designates a function key "ab" as defined
by termcap(5); thus bindings to function keys can be made independent of
the actual terminal type. Note the "set quiet" commands around the function
key bindings; this is good practice since it prevents spurious error
messages if a function key happens to be undefined for a particularly dumb
terminal type).
.LP
JOVE also reads commands from the a file called ".joverc" in the current
directory.  This is convenient, for instance, to accomodate to
indentation styles of different software packages.
.SH SOME MINOR DETAILS
You should type C-\e instead of C-S in many instances.  For example, the way
to search for a string is documented as being "C-S" but in reality you
should type "C-\e".  This is because C-S is the XOFF character (what gets
sent when you type the NO SCROLL key), and clearly that won't work.  The XON
character is "C-Q" (what gets sent when you type NO SCROLL again) which is
documented as the way to do a quoted-insert.  The alternate key for this is
"C-^" (typed as "C-`" on vt100's and its look-alikes).  If you want to
enable C-S and C-Q whenever possible, you can put the line:
.sp
.ti +5
     eval `xon-xoff -f -s`
.sp
in your shell startup file.  This will test the terminal's need for
XON-XOFF synchronization and stores the result in an environment
variable.
If your communication link doesn't pass C-S and C-Q, you can use C-\e and
C-^ as synonyms in most situations.
.LP
.ig
If your terminal has a metakey, JOVE will use it if you turn on the
"meta-key" variable.  JOVE will automatically turn on "meta-key" if the
METAKEY environment variable exists.  This is useful for if you have
different terminals (e.g., one at home and one at work) and one has a
metakey and the other doesn't.
..
If your terminal has a metakey, JOVE will use it unless you turn off the
"meta-key" variable.
.SH FILES
LIBDIR/joverc \- system wide initialization file
.sp 0
~/.joverc \- personal initialization file
.sp 0
\&./.joverc \- directory specific initialization file
.sp 0
~/.jovehelp \- on-line help database for personal macros
.sp 0
LIBDIR/joveabbr \- system wide abbreviation definitions
.sp 0
TMPDIR \- where temporary files are stored
.sp 0
LIBDIR/teach-jove \- the interactive tutorial
.sp 0
.ig
LIBDIR/kbd,
.sp 0
LIBDIR/portsrv \- for running shells in windows (non-bsd only)
.sp 0
..
LIBDIR/cmds.doc \- the on-line help database
.sp 0
LIBDIR/extra.hlp \- additional help screens
.sp 0
LIBDIR/keysubst \- support program for additional help
.SH ENVIRONMENT VARIABLES
COLUMNS, LINES (UNIX, VMS) \- determine screen size
.sp 0
CWD or PWD (UNIX) \- to determine current directory
.sp 0
DIRS \- to determine directory stack
.sp 0
ES\&HELL \- explicit interactive shell
.sp 0
JOVEDIR (Atari, MS-DOS) \- to find JOVEs library directory
.sp 0
HOME \- to determine your HOME directory
.sp 0
KEYB (MS-DOS) \- what keyboard is in use
.sp 0
LOGNAME or USER (UNIX) \- to find your login name
.sp 0
MAIL (UNIX) \- to check your mailbox
.sp 0
METAKEY \- determine if "meta-key" should be set (to ESC)
.sp 0
OLDPWD \- to initialize "=-" directory
.sp 0
S\&HELL \- to initialize "shell" variable
.sp 0
TERM \- to determine terminal type
.sp 0
TERMCAP (UNIX, VMS) \- to find the terminal database
.sp 0
TERMWHITE \- if terminal has "white" background color
.sp 0
TMP or T\&MPDIR (Atari, MS-DOS) \- to initialize "tmp-file-pathname"
.sp 0
XONXOFF \- set by xon-xoff(1), to initialize "allow-^S-and-^Q".
.SH SEE ALSO
JOVE Users Manual \- for the full story
.sp 0
ed(1) \- for a description of regular expressions
.sp 0
teachjove(1) \- for an interactive JOVE tutorial
.sp 0
xon-xoff(1) \- check if your terminal needs flow control.
.SH DIAGNOSTICS
JOVE diagnostics are meant to be self-explanatory, but you are advised
to seek help whenever you are confused.  You can easily lose a lot of
work if you don't know EXACTLY what you are doing.
.SH BUGS
Lines can't be more than 1023 characters long. (511 on small systems)
.sp 0
Searches can't cross line boundaries.
.SH AUTHOR
Jonathan Payne
.sp 0
major revisions by Tom Hageman (tom@basil.icce.rug.nl)
.ig
.\"=====================================================================
.\" $Log: jove.nr,v $
.\" Revision 14.32.0.1  1993/07/30  13:27:15  tom
.\" fix spacing in some .nr directives to get it through groff without warnings.
.\"
.\" Revision 14.32  1993/06/30  17:51:12  tom
.\" *** empty log message ***
.\"
.\" Revision 14.30  1993/02/09  23:08:22  tom
.\" complete description of environment variables used by JOVE; cleanup Log.
.\"
.\" Revision 14.28  1992/10/28  02:09:05  tom
.\" locked.
.\"
.\" Revision 14.27  1992/09/13  22:54:39  tom
.\" fix some formatting botches; protect literal SHELL etc. against substitution.
.\"
.\" Revision 14.26  1992/08/26  23:57:14  tom
.\" add RCS directives
.\"
.\"=====================================================================
..
