/*+++*
 *  RCS		$Id: termcap.h,v 1.4 1993/04/05 14:04:10 tom Exp tom $
 *  title:	termcap.h
 *  abstract:	public definitions for termcap(5) library routines.
 *  author:	T.R.Hageman, Groningen, The Netherlands.
 *  created:	June 1992
 *  modified:
 *  description:
 *---*/

#ifndef _TERMCAP_H_
#define _TERMCAP_H_

/*	Portability macros.						     */

#ifndef _PORTDEFS_H_
#   include "portdefs.h"
#endif

/*	Constants.							     */

#define TBUFSIZE 2048			/* Assumed buffer size for tgetent() */


/*	Function prototypes.						     */

extern int	tgetent	 __(( char _(buf)[TBUFSIZE], const char *_(name) ));
extern int	tgetflag __(( const char *_(id) ));
extern int	tgetnum	 __(( const char *_(id) ));
extern char	*tgetstr __(( const char *_(id), char **_(area) ));
extern char	*tgoto	 __(( const char *_(cm), int _(col), int _(line) ));
extern int	tputs	 __(( const char *_(cap), int _(lines), 
			      int (*_(outc))(int) ));

/*	Gnu termcap extensions:						     */

extern char	*tparam	 __(( const char *_(fmt),
			      char *_(buf), int _(size), ... ));

#endif /* _TERMCAP_H_ */

/*======================================================================*
 * $Log: termcap.h,v $
 * Revision 1.4  1993/04/05  14:04:10  tom
 * (_TERMCAP_H_): trailing underscore added; fix typo in RCS Log.
 *
 *======================================================================*/
